/****************************************************************************
 *
 * Copy right:   2017-, Copyrigths of EigenComm Ltd.
 * File name:    app.h
 * Description:  EC616 onenet demo entry header file
 * History:      Rev1.0   2018-07-12
 *
 ****************************************************************************/
#ifndef  APP_H
#define  APP_H

#ifdef __cplusplus
extern "C" {
#endif

#include "cisAsynEntry.h"

#define QMSG_ID_BASE               (0x160) 
#define QMSG_ID_NW_IP_READY        (QMSG_ID_BASE)
#define QMSG_ID_NW_IP_SUSPEND      (QMSG_ID_BASE + 1)
#define QMSG_ID_NW_IP_NOREACHABLE  (QMSG_ID_BASE + 2)
#define QMSG_ID_SOCK_SENDPKG       (QMSG_ID_BASE + 4)
#define QMSG_ID_SOCK_RECVPKG       (QMSG_ID_BASE + 5)
#define QMSG_ID_SOCK_EXIT       (QMSG_ID_BASE + 6)
typedef enum
{
    APP_INIT_STATE,
    APP_DEACTIVE_STATE,
    APP_IPREADY_STATE,
    APP_REPORT_STATE,
    APP_IDLE_STATE,
    APP_WAIT_STATE
} appRunningState_t;
typedef enum
{
    APP_SOCKET_CONNECTION_CLOSED,
    APP_SOCKET_CONNECTION_CONNECTING,
    APP_SOCKET_CONNECTION_CONNECTED,    
}AppSocketConnectionStatus;

typedef struct AppSocketConnectionContext_Tag
{
    INT32 id;
    INT32 status;
}AppSocketConnectionContext;

typedef struct Uart_Receive_Type
{
    uint8_t Bms_Address; 
    uint8_t Bms_Read_Funcode; 
    uint8_t Reg_Begin_H; 
    uint8_t Reg_Begin_L; 
    uint8_t Reg_Num_H; 
    uint8_t Reg_Num_L; 
}Uart_Receive_Type;

typedef struct Fota_Type
{
    bool Fota_update_flag ;
    bool Fota_update_error ;
    uint32_t Fota_All_Data_Len ;
    uint32_t Fota_Current_Addres ;
    uint8_t Fota_Recv_Data_Len ;
    uint8_t Fota_Recv_Data[100] ;
    uint32_t Fota_Flash_Addres;
    uint8_t Fota_CRC ;

}Fota_Type;
typedef struct  _GPS_INFO
{
	uint8_t timedata[6];
	uint8_t status;
	uint8_t satellite_num;
	uint16_t direction;
	uint16_t speed;
	uint16_t altitude;
	uint32_t latitude;
	uint32_t longitude;
}GPS_INFO;
uint8_t* Uart_Receive_func(Uart_Receive_Type Uart_Receive_Msg,uint8_t* Uart_Rece_buffer,uint8_t Data_Len);

#ifdef __cplusplus
}
#endif
#endif /* APP_H */
