/*******************************
 * 
 * 骑享OTA更新测试
 * 
 * ****************************/
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "app.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include <cis_def.h>
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"
#include "ec_tcpip_api.h"

//Main Area
#define PROC_MAIN_TASK_STACK_SIZE           (1024)
uint8_t deepslpTimerID          = DEEPSLP_TIMER_ID7;
uint8_t MainSlpHandler          = 0xff;
static StaticTask_t             gProcess_Main_Task_t;
static UINT8                  gProcess_Main_TaskStack[PROC_MAIN_TASK_STACK_SIZE];
typedef enum
{
    PROCESS_STATE_IDLE = 0,
    PROCESS_STATE_WORK,
    PROCESS_STATE_SLEEP
}process_Main;
static process_Main 		    gProcess_Main_Task = PROCESS_STATE_IDLE;
#define PROC_MAIN_STATE_SWITCH(a)  (gProcess_Main_Task = a)

//tcp area
#define PROC_TCP_TASK_STACK_SIZE           (1024*2)
static StaticTask_t             gProcess_Tcp_Task_t;
static UINT8                  gProcess_Tcp_TaskStack[PROC_TCP_TASK_STACK_SIZE];
static volatile UINT32          Event;
static UINT8                    gImsi[16] = {0};
static INT32                    sockfd = -1;
static UINT32                   gCellID = 0;
static UINT8  Tcp_serviece;
static QueueHandle_t            psEventQueueHandle;//队列句柄
#define APP_EVENT_QUEUE_SIZE    (10)//队列大小
static AppSocketConnectionContext socContext = {-1, APP_SOCKET_CONNECTION_CLOSED};
//fota area
Fota_Type Fota_S={0,0,0,0,0,0,0,0};
//函数声明
void Tcp_Recv_info(uint8_t* p);
void Tcp_Recv_fota(uint8_t* p);
//睡眠进出函数
static void appBeforeHib(void *pdata, slpManLpState state)
{
    uint32_t *p_param = (uint32_t *)pdata;

    #ifdef USING_PRINTF
        printf("Before Hibernate:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);

}

static void appAfterHib(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Try Hibernate Failed:%d \n",state);
    #endif
}

static void appBeforeSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Before Sleep1:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}

static void appAfterSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("After Sleep1:%d \n",state);
    #endif
}


static void appBeforeSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("before sleep2:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}

static void appAfterSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("sleep2 failed:%d \n",state);
    #endif
}
//Tcp 状态转换函数
static void sendQueueMsg(UINT32 msgId, UINT32 xTickstoWait)
{
    eventCallbackMessage_t *queueMsg = NULL;
    queueMsg = malloc(sizeof(eventCallbackMessage_t));
    queueMsg->messageId = msgId;
    if (psEventQueueHandle)
    {
        if (pdTRUE != xQueueSend(psEventQueueHandle, &queueMsg, xTickstoWait))
        {
            ECOMM_TRACE(UNILOG_PLA_APP, sendQueueMsg_1, P_ERROR, 0, "xQueueSend error");
        }
    }
}
// 主任务线程
static void Main_Task(void* arg)
{
    UINT16 Can_index = 0;
    UINT16 Uart_index = 0;
    UINT16 Tcp_index  = 0;
    uint32_t sleep_index = 0;
    uint32_t sleep_time_flag;
    int32_t inParam = 0xAABBCCDD;
    uint32_t Chrgend_Work_time = 1800;
    uint32_t Wakeup_Work_time = 120;
    uint32_t Sleep_Time = 120;
    //上述参数应写入文件里
    slpManWakeSrc_e Wakeup_source;
    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_IDLE);
    NetSocDisplay(LED_SOC_0,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_1,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_2,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_3,LED_TURN_OFF);
    FaultDisplay(LED_TURN_OFF);
    NVIC_EnableIRQ(PadWakeup1_IRQn);

    slpManSetPmuSleepMode(true,SLP_HIB_STATE,false);
    slpManApplyPlatVoteHandle("MainSlp",&MainSlpHandler);
    slpManPlatVoteDisableSleep(MainSlpHandler, SLP_SLP2_STATE); 
    slpManRegisterUsrdefinedBackupCb(appBeforeHib,&inParam,SLPMAN_HIBERNATE_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterHib,NULL,SLPMAN_HIBERNATE_STATE);
    slpManRegisterUsrdefinedBackupCb(appBeforeSlp1,NULL,SLPMAN_SLEEP1_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp1,NULL,SLPMAN_SLEEP1_STATE);
    slpManRegisterUsrdefinedBackupCb(appBeforeSlp2,NULL,SLPMAN_SLEEP2_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp2,NULL,SLPMAN_SLEEP2_STATE);

    slpManSlpState_t slpstate = slpManGetLastSlpState();

    #ifdef USING_PRINTF
            printf("slpstate:%d \n",slpstate);
    #endif
    Wakeup_source =  slpManGetWakeupSrc();//获取唤醒源
    #ifdef USING_PRINTF
            printf("Wakeup_source:%d \n",Wakeup_source);
    #endif
    if (Wakeup_source==0)
    {
        sleep_time_flag = Wakeup_Work_time;
    }
    else if (Wakeup_source==1)
    {
        sleep_time_flag = Wakeup_Work_time;
    }
    else
    {
        sleep_time_flag = Chrgend_Work_time;
    }
    if((slpstate == SLP_SLP2_STATE) || (slpstate == SLP_HIB_STATE))
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
    }
    else
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
    }
    while (true)
    {
        switch(gProcess_Main_Task)
        {
            case PROCESS_STATE_IDLE:
            {
                // 暂时不区分唤醒
                PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
                break;
            }
            case PROCESS_STATE_WORK:
            {
                osDelay(10/portTICK_PERIOD_MS);
                Can_index++;
                Uart_index++;
                Tcp_index++;
                sleep_index++;
                if(Tcp_index>5*100 && socContext.id>=0)
                {
                    sendQueueMsg(QMSG_ID_SOCK_SENDPKG, 0);
                    Tcp_index = 0;
                }
                if (sleep_index >=sleep_time_flag*100)
                {
                    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_SLEEP);
                    sleep_index = 0;
                }
                break;
            }
            case PROCESS_STATE_SLEEP:
            {
                sendQueueMsg(QMSG_ID_SOCK_EXIT, 0);
                osDelay(5000);
                slpManSlpState_t State;
                uint8_t cnt;
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif						
                }
                slpManPlatVoteForceEnableSleep(MainSlpHandler, SLP_SLP2_STATE); //增加强制投票
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State Again, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif					
                }
                #ifdef USING_PRINTF
                            printf("[%d]Waiting sleep\r\n",__LINE__);
                #endif
                FaultDisplay(LED_TURN_ON);
                slpManSlpState_t slpstate = slpManPlatGetSlpState();
                #ifdef USING_PRINTF
                    printf("which slpstate can go now :%d \n",slpstate);
                #endif
                slpManDeepSlpTimerStart(deepslpTimerID, Sleep_Time);
                while(1)
                {
                    if(!slpManDeepSlpTimerIsRunning(deepslpTimerID))
                    {
                        slpManDeepSlpTimerDel(deepslpTimerID);
                    }
                    slpManDeepSlpTimerStart(deepslpTimerID, Sleep_Time*1000);
                    osDelay(60000/portTICK_PERIOD_MS);
                }
                break;
            }
        }

    }
    

}
static INT32 socketRegisterPSUrcCallback(urcID_t eventID, void *param, UINT32 paramLen)
{
    CmiSimImsiStr *imsi = NULL;
    CmiPsCeregInd *cereg = NULL;

    UINT8 rssi = 0, index = 0;
    NmAtiNetifInfo *netif = NULL;

    switch(eventID)
    {
        case NB_URC_ID_SIM_READY:
        {
            imsi = (CmiSimImsiStr *)param;
            memcpy(gImsi, imsi->contents, imsi->length);
            #ifdef USING_PRINTF
                printf("SIM ready(imsi=%s)\n",(UINT8 *)imsi->contents);
            #endif
            break;
        }
        case NB_URC_ID_MM_SIGQ:
        {
            rssi = *(UINT8 *)param;
            #ifdef USING_PRINTF
                printf("RSSI signal=%d\n",rssi);
            #endif
            break;
        }
        case NB_URC_ID_PS_BEARER_ACTED:
        {
            #ifdef USING_PRINTF
                printf("Default bearer activated\n");
            #endif
            break;
        }
        case NB_URC_ID_PS_BEARER_DEACTED:
        {
            #ifdef USING_PRINTF
                printf("Default bearer Deactivated\n");
            #endif
            break;
        }
        case NB_URC_ID_PS_CEREG_CHANGED:
        {
            cereg = (CmiPsCeregInd *)param;
            gCellID = cereg->celId;
            #ifdef USING_PRINTF
                printf("URCCallBack:CEREG changed act:%d celId:%d locPresent:%d tac:%d\n", cereg->act, cereg->celId, cereg->locPresent, cereg->tac);
            #endif
            break;
        }
        case NB_URC_ID_PS_NETINFO:
        {
            netif = (NmAtiNetifInfo *)param;
            if (netif->netStatus == NM_NETIF_ACTIVATED)
                sendQueueMsg(QMSG_ID_NW_IP_READY, 0);
            break;
        }
    }
    return 0;
}
void socketAppConnectionCallBack(UINT8 connectionEventType, void *bodyEvent)
{
    switch(connectionEventType)
    {
        case TCPIP_CONNECTION_STATUS_EVENT:
        {
            TcpipConnectionStatusInd *statusInd;
            statusInd = (TcpipConnectionStatusInd *)bodyEvent;
            if(statusInd != PNULL)
            {
                if(statusInd->status == TCPIP_CONNECTION_STATUS_CLOSED)
                {
                    #ifdef USING_PRINTF
                        printf("socketAppConnectionCallBack socket connection %u closed,cause %u", statusInd->connectionId, statusInd->cause);
                    #endif
                    ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_1, P_ERROR, 2, "socketAppConnectionCallBack socket connection %u closed,cause %u", statusInd->connectionId, statusInd->cause);
                    if(statusInd->connectionId == socContext.id)
                    {
                        socContext.id = -1;
                        socContext.status = APP_SOCKET_CONNECTION_CLOSED;
                    }
                }
                else if(statusInd->status == TCPIP_CONNECTION_STATUS_CONNECTING)
                {
                    #ifdef USING_PRINTF
                        printf("socketAppConnectionCallBack socket connection %u is connecting", statusInd->connectionId);
                    #endif
                    ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_2, P_INFO, 1, "socketAppConnectionCallBack socket connection %u is connecting", statusInd->connectionId);
                    if(statusInd->connectionId == socContext.id)
                    {
                        socContext.status = APP_SOCKET_CONNECTION_CONNECTING;
                    }
                }
                else if(statusInd->status == TCPIP_CONNECTION_STATUS_CONNECTED)
                {
                    #ifdef USING_PRINTF
                        printf("socketAppConnectionCallBack socket connection %u is connected", statusInd->connectionId);
                    #endif
                    ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_3, P_ERROR, 1, "socketAppConnectionCallBack socket connection %u is connected", statusInd->connectionId);
                    if(statusInd->connectionId == socContext.id)
                    {
                        socContext.status = APP_SOCKET_CONNECTION_CONNECTED;
                    }
                }
            }
            else
            {
                #ifdef USING_PRINTF
                    printf("socketAppConnectionCallBack invalid connection status event");
                #endif
                ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_4, P_ERROR, 0, "socketAppConnectionCallBack invalid connection status event");
            }

            break;
        }
        case TCPIP_CONNECTION_RECEIVE_EVENT:
        {
            TcpipConnectionRecvDataInd *rcvInd;
            rcvInd = (TcpipConnectionRecvDataInd *)bodyEvent;
            if(rcvInd != PNULL)
            {
                uint8_t* Ptr;
                #ifdef USING_PRINTF
                
                    Ptr=rcvInd->data;
                    printf("socketAppConnectionCallBack socket connection %u receive length %u data:", rcvInd->connectionId, rcvInd->length);
                    for(int i = 0;i<rcvInd->length;i++)
                        printf("%x",*(Ptr+i));
                #endif
                Tcp_Recv_info(Ptr);//Tcp 接收
                ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_5, P_INFO, 2, "socketAppConnectionCallBack socket connection %u receive length %u data", rcvInd->connectionId, rcvInd->length);
            }
            else
            {
                #ifdef USING_PRINTF
                    printf( "socketAppConnectionCallBack invalid connection rcv event");
                #endif
                ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_6, P_ERROR, 0, "socketAppConnectionCallBack invalid connection rcv event");
            }
            break;
        }
        case TCPIP_CONNECTION_UL_STATUS_EVENT:
        {
            TcpipConnectionUlDataStatusInd *ulStatusInd;
            ulStatusInd = (TcpipConnectionUlDataStatusInd *)bodyEvent;
            if(ulStatusInd != PNULL)
            {
                if(ulStatusInd->status == Tcpip_Connection_UL_DATA_SUCCESS)
                {
                    #ifdef USING_PRINTF
                        printf( "socketAppConnectionCallBack socket connection %u sequence %u data has sent success", ulStatusInd->connectionId, ulStatusInd->sequence);
                    #endif
                    ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_7, P_INFO, 2, "socketAppConnectionCallBack socket connection %u sequence %u data has sent success", ulStatusInd->connectionId, ulStatusInd->sequence);
                }
                else if(ulStatusInd->status == Tcpip_Connection_UL_DATA_FAIL)
                {
                    #ifdef USING_PRINTF
                        printf("socketAppConnectionCallBack socket connection %u sequence %u data has sent fail", ulStatusInd->connectionId, ulStatusInd->sequence);
                    #endif
                    ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_8, P_WARNING, 2, "socketAppConnectionCallBack socket connection %u sequence %u data has sent fail", ulStatusInd->connectionId, ulStatusInd->sequence);
                }
            }
            else
            {
                #ifdef USING_PRINTF
                    printf("socketAppConnectionCallBack invalid connection ul status event");
                #endif
                ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_9, P_ERROR, 0, "socketAppConnectionCallBack invalid connection ul status event");
            }
            break;
        }
        default:
            #ifdef USING_PRINTF
                printf("socketAppConnectionCallBack invalid event type %u", connectionEventType);
            #endif
            ECOMM_TRACE(UNILOG_PLA_APP, socketAppConnectionCallBack_10, P_ERROR, 1, "socketAppConnectionCallBack invalid event type %u", connectionEventType);
            break;
    }
    
}
void Tcp_Recv_fota(uint8_t* P)
{
    #ifdef USING_PRINTF
        printf("fota data handle\n");
    #endif
}
void Tcp_Recv_info(uint8_t* P)
{
    switch(*(P+1))
    {
        case 0x00://非应答
            Tcp_serviece=01;
            break;
        case 0xfe://应答
            Tcp_serviece=01;
            switch(*(P))
            {
                case 0x80:
                    break;
                case 0x82:
                    Fota_S.Fota_update_flag=true;
                    Tcp_Recv_fota(P);
                    break;
                default:
                    Fota_S.Fota_update_flag = false;
            }
            break;
    }
}
uint8_t Fota_crc_chk(uint8_t* data,uint8_t length)
{  
    uint8_t reg_crc=0x00;
    while(length--)
    { 
        reg_crc ^= *data++;
    }
    return reg_crc;
}
void Tcp_Send_fota()
{
    tcpipConnectionSend(socContext.id, "fota", 5, 0, 0, 0);
}
void Tcp_Send_info()
{
    static UINT8 send_counter=0;   
    int len;
    if(send_counter%1==0)
    {
        len = tcpipConnectionSend(socContext.id, {02,00,80}, 4, 0, 0, 0);
    }
    if(send_counter%6==0)
    {
        len = tcpipConnectionSend(socContext.id, {01 00}, 3, 0, 0, 0);
    }
    if(send_counter>=6*10+1)
    {
        send_counter=1;
    }
    else 
    {
        send_counter++;
    }

    if(len > 0)
    {
        #ifdef USING_PRINTF
            printf("connection %u send len %u success", socContext.id, len);
        #endif
        ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_7, P_INFO, 2, "connection %u send len %u success", socContext.id, len);  
    }
    else
    {
        #ifdef USING_PRINTF
            printf("connection %u sent data fail", socContext.id);
        #endif
        ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_8, P_ERROR, 1, "connection %u sent data fail", socContext.id);
    }
}
static void Tcp_Task(void* arg)
{
    uint16 send_counter;
    eventCallbackMessage_t *queueItem = NULL;
    appSetEDRXSettingSync(0,5,1800000);
    appSetPSMSettingSync(1,3*60*60,10);
    CHAR   APP_SOCKET_DAEMON_SERVER_IP[] = "120.26.68.165";
    uint16_t   APP_SOCKET_DAEMON_SERVER_PORT = 14319;
    INT32 connectionId = -1;
    INT32 len;
    UINT8 data[8] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
    psEventQueueHandle = xQueueCreate(APP_EVENT_QUEUE_SIZE, sizeof(eventCallbackMessage_t*));
    if (psEventQueueHandle == NULL)
    {
        return;
    }
    appSetCFUN(1);
    while(1){
        if (xQueueReceive(psEventQueueHandle, &queueItem, portMAX_DELAY))
        {
            #ifdef USING_PRINTF
                printf("Queue receive->0x%x\n", queueItem->messageId);
            #endif
            switch(queueItem->messageId)
            {
                case QMSG_ID_NW_IP_READY:
                    connectionId = tcpipConnectionCreate(TCPIP_CONNECTION_PROTOCOL_TCP, PNULL, 0, APP_SOCKET_DAEMON_SERVER_IP, APP_SOCKET_DAEMON_SERVER_PORT, socketAppConnectionCallBack);
                    if(connectionId >= 0)
                    {
                        socContext.id = connectionId;
                        socContext.status = APP_SOCKET_CONNECTION_CONNECTED;
                        #ifdef USING_PRINTF
                            printf("create connection %u success", socContext.id);
                        #endif
                        ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_2, P_INFO, 1, "create connection %u success", socContext.id);
                    }
                    else
                    {
                        #ifdef USING_PRINTF
                            printf("create connection fail\n");
                        #endif
                        ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_3, P_ERROR, 0, "create connection fail");
                    }
                    break;
                case QMSG_ID_NW_IP_NOREACHABLE:
                    break;
                case QMSG_ID_SOCK_SENDPKG:
                    if (socContext.id >= 0 && socContext.status == APP_SOCKET_CONNECTION_CONNECTED)
                    {
                        if(Tcp_Servies)
                        {
                            Tcp_Send_info();
                        }
                    }
                    else
                    {
                        #ifdef USING_PRINTF
                            printf("connection %u or status invalid", socContext.id, socContext.status);
                        #endif
                        ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_9, P_ERROR, 2, "connection %u or status invalid", socContext.id, socContext.status); 
                    }
                    break;
                case QMSG_ID_NW_IP_SUSPEND:
                    if (socContext.id >= 0 && socContext.status != APP_SOCKET_CONNECTION_CLOSED)
                    {
                        if(tcpipConnectionClose(socContext.id) < 0)
                        {
                            socContext.id = -1;
                            socContext.status = APP_SOCKET_CONNECTION_CLOSED;
                            #ifdef USING_PRINTF
                                printf("close connection %u success", socContext.id);
                            #endif
                            ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_4, P_INFO, 1, "close connection %u success", socContext.id);                            
                        }
                        else
                        {
                            #ifdef USING_PRINTF
                                printf("close connection %u fail", socContext.id);
                            #endif
                            ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_5, P_ERROR, 1, "close connection %u fail", socContext.id);
                        }
                    }
                    else
                    {
                        #ifdef USING_PRINTF
                            printf("connection %u or status invalid", socContext.id, socContext.status);
                        #endif
                        ECOMM_TRACE(UNILOG_PLA_APP, ecTestCaseTcpClient_6, P_ERROR, 2, "connection %u or status invalid", socContext.id, socContext.status); 
                    }                    
                    break;
                case QMSG_ID_SOCK_EXIT:
                    #ifdef USING_PRINTF
                        printf("socket disconnect\n");
                    #endif
                    if (sockfd >= 0)
                    {
                       close(sockfd);
                       sockfd = -1;
                    }
                    appSetCFUN(0);
                    free(queueItem);
                    osThreadExit();
            }
            free(queueItem);
        }
    }
}
//Tcp线程初始化
void Tcp_Task_Init()
{
    osThreadAttr_t task_attr;
    registerPSEventCallback(NB_GROUP_ALL_MASK, socketRegisterPSUrcCallback);
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Tcp_TaskStack, 0xA5, PROC_TCP_TASK_STACK_SIZE);
    task_attr.name = "Tcp_Task";
    task_attr.stack_mem = gProcess_Tcp_TaskStack;
    task_attr.stack_size = PROC_TCP_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Tcp_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Tcp_Task, NULL, &task_attr);
}

//主任务线程初始化
void Main_Task_Init()
{
    #ifndef USING_PRINTF
    if(BSP_GetPlatConfigItemValue(PLAT_CONFIG_ITEM_LOG_CONTROL) != 0)
    {
        HAL_UART_RecvFlowControl(false);
    }
    #endif
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Main_TaskStack, 0xA5, PROC_MAIN_TASK_STACK_SIZE);
    task_attr.name = "Main_Task";
    task_attr.stack_mem = gProcess_Main_TaskStack;
    task_attr.stack_size = PROC_MAIN_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Main_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Main_Task, NULL, &task_attr);
}
void appInit(void *arg)
{
    Main_Task_Init();
    Tcp_Task_Init();
}
//主函数入口
void main_entry(void) 
{
    BSP_CommonInit();
    osKernelInitialize();
    registerAppEntry(appInit, NULL);
    if (osKernelGetState() == osKernelReady)
    {
        osKernelStart();
    }
    while(1);
}
